import { ModuleDescription, ModuleData } from "./IAdventure";
import { PdfData } from "../parse";
import * as Core from "./core";

const crbModule : ModuleDescription = {
    prefix: "crb",
    fullName: "Pathfinder 2E Core Rulebook",
    detect: (pdf: PdfData) => {
        return pdf.textDetails.some(t => t.text == 'Core Rulebook' && t.fontId == 'Taroca:45');
    },
    detectPageLayout: Core.detectPageLayout,
    extractDetails: Core.extractDetails,
    pages: [
        // chapter 1
        new Core.RightChapterHeading(8),
        new Core.LeftTwoColumn(9),
        new Core.RightOneColumnWithSidebar(10),
        new Core.LeftTwoColumn(11),
        new Core.RightTwoColumnWithMap(12),
        new Core.LeftTwoColumn(13),
        new Core.RightTwoColumn(14),
        new Core.LeftTwoColumn(15),
        new Core.RightTwoColumn(16),
        new Core.LeftTwoColumn(17),
        new Core.RightOneColumnWithSidebar(18),
        new Core.LeftTwoColumnWithMap(19),

        // chapter 2
        new Core.RightChapterHeading(34),
        // dwarf
        new Core.LeftChapterHeading(35),
        new Core.RightOneColumnWithSidebar(36),
        new Core.LeftTwoColumnWithMap(37),
        new Core.RightOneColumnWithSidebar(38),
        // elf
        new Core.LeftChapterHeading(39),
        new Core.RightOneColumnWithSidebar(40, 68.5237),
        new Core.LeftTwoColumn(41),
        new Core.RightOneColumnWithSidebar(42),
        // gnome
        new Core.LeftChapterHeading(43),
        new Core.RightOneColumnWithSidebar(44),
        new Core.LeftTwoColumn(45),
        new Core.RightOneColumnWithSidebar(46),
        // goblin
        new Core.LeftChapterHeading(47),
        new Core.RightOneColumnWithSidebar(48),
        new Core.LeftTwoColumn(49),
        new Core.RightOneColumnWithSidebar(50),
        // halfling
        new Core.LeftChapterHeading(51),
        new Core.RightOneColumnWithSidebar(52),
        new Core.LeftTwoColumn(53),
        new Core.RightOneColumnWithSidebar(54),
        // human
        new Core.LeftChapterHeading(55),
        new Core.RightOneColumnWithSidebar(56),
        new Core.LeftTwoColumn(57),
        new Core.RightTwoColumn(58),
        new Core.LeftTwoColumn(59),
        new Core.RightTwoColumn(60),
        // backgrounds
        new Core.LeftChapterHeading(61),
        new Core.RightTwoColumnWithMap(62),
        new Core.LeftTwoColumn(63),
        new Core.RightTwoColumn(64),
        new Core.LeftTwoColumnWithMap(65),
        // languages
        new Core.RightChapterHeading(66),
        
        // chapter 3
        new Core.RightChapterHeading(68),
        new Core.LeftTwoColumn(69),
        // alchemist
        new Core.RightChapterHeadingWithSidebar(72, 70.56),
        new Core.LeftTwoColumn(73),
        new Core.RightTwoColumn(74),
        new Core.LeftTwoColumnWithLeftSidebar(75),
        new Core.RightTwoColumn(76),
        new Core.LeftOneColumnWithLeftSidebar(77),
        new Core.RightTwoColumnWithMap(78),
        new Core.LeftTwoColumnWithLeftSidebar(79),
        new Core.RightTwoColumn(80),
        new Core.LeftTwoColumnWithLeftSidebar(81),
        new Core.RightTwoColumn(82),
        // barbarian
        new Core.RightChapterHeadingWithSidebar(84),
        new Core.LeftTwoColumn(85),
        new Core.RightTwoColumn(86),
        new Core.LeftTwoColumn(87),
        new Core.RightTwoColumn(88),
        new Core.LeftOneColumnWithLeftSidebar(89),
        new Core.RightTwoColumnWithMap(90),
        new Core.LeftTwoColumnWithLeftSidebar(91),
        new Core.RightTwoColumn(92),
        new Core.LeftTwoColumnWithLeftSidebar(93),
        // bard
        new Core.RightTwoColumn(94),
        new Core.RightOneColumnWithSidebar(96),
        new Core.LeftTwoColumn(97),
        new Core.RightTwoColumn(98),
        new Core.LeftTwoColumn(99),
        new Core.RightTwoColumn(100),
        new Core.LeftOneColumnWithLeftSidebar(101),
        new Core.RightTwoColumnWithMap(102),
        new Core.LeftTwoColumnWithLeftSidebar(103),
        new Core.RightTwoColumn(104),
        // champion
        new Core.RightChapterHeadingWithSidebar(106),
        new Core.LeftTwoColumn(107),
        new Core.RightTwoColumn(108),
        new Core.LeftTwoColumn(109),
        new Core.RightTwoColumn(110),
        new Core.LeftOneColumnWithLeftSidebar(111),
        new Core.RightTwoColumnWithMap(112),
        new Core.LeftTwoColumnWithLeftSidebar(113),
        new Core.RightTwoColumn(114),
        new Core.LeftTwoColumnWithLeftSidebar(115),
        new Core.RightTwoColumn(116),
        // cleric
        new Core.RightChapterHeadingWithSidebar(118),
        new Core.LeftTwoColumn(119),
        new Core.RightTwoColumn(120),
        new Core.LeftTwoColumn(121),
        new Core.RightTwoColumn(122),
        new Core.LeftOneColumnWithLeftSidebar(123),
        new Core.RightTwoColumn(124),
        new Core.LeftTwoColumnWithLeftSidebar(125),
        new Core.RightTwoColumn(126),
        new Core.LeftTwoColumnWithLeftSidebar(127),
        new Core.RightTwoColumnWithMap(128),
        // druid
        new Core.RightChapterHeadingWithSidebar(130),
        new Core.LeftTwoColumn(131),
        new Core.RightTwoColumn(132),
        new Core.LeftTwoColumn(133),
        new Core.RightTwoColumn(134),
        new Core.LeftTwoColumnWithLeftSidebar(135),
        new Core.RightOneColumnWithSidebar(136),
        new Core.LeftTwoColumnWithLeftSidebar(137),
        new Core.RightTwoColumnWithMap(138),
        new Core.LeftTwoColumnWithLeftSidebar(139),
        new Core.RightTwoColumn(140),
        // fighter
        new Core.RightChapterHeadingWithSidebar(142),
        new Core.LeftTwoColumn(143),
        new Core.RightTwoColumn(144),
        new Core.LeftOneColumnWithLeftSidebar(145),
        new Core.RightOneColumnWithSidebar(146),
        new Core.LeftTwoColumn(147),
        new Core.RightTwoColumnWithMap(148),
        new Core.LeftTwoColumnWithLeftSidebar(149),
        new Core.RightTwoColumn(150),
        new Core.LeftTwoColumnWithLeftSidebar(151),
        new Core.RightTwoColumn(152),
        new Core.LeftTwoColumnWithLeftSidebar(153),
        new Core.RightTwoColumn(154),
        // monk
        new Core.RightChapterHeadingWithSidebar(156),
        new Core.LeftTwoColumn(157),
        new Core.RightTwoColumn(158),
        new Core.LeftOneColumnWithLeftSidebar(159),
        new Core.RightTwoColumn(160),
        new Core.LeftTwoColumn(161),
        new Core.RightTwoColumnWithMap(162),
        new Core.LeftTwoColumnWithLeftSidebar(163),
        new Core.RightTwoColumn(164),
        new Core.LeftTwoColumnWithLeftSidebar(165),
        new Core.RightTwoColumn(166),        
        // ranger
        new Core.RightChapterHeadingWithSidebar(168),
        new Core.LeftTwoColumn(169),
        new Core.RightTwoColumn(170),
        new Core.LeftOneColumnWithLeftSidebar(171),
        new Core.RightTwoColumn(172),
        new Core.LeftTwoColumn(173),
        new Core.RightTwoColumnWithMap(174),
        new Core.LeftTwoColumnWithLeftSidebar(175),
        new Core.RightTwoColumn(176),
        new Core.LeftTwoColumnWithLeftSidebar(177),
        new Core.RightTwoColumn(178),
        // rogue
        new Core.RightChapterHeadingWithSidebar(180),
        new Core.LeftTwoColumn(181),
        new Core.RightTwoColumn(182),
        new Core.LeftTwoColumn(183),
        new Core.RightOneColumnWithSidebar(184),
        new Core.LeftTwoColumnWithLeftSidebar(185),
        new Core.RightTwoColumnWithMap(186),
        new Core.LeftTwoColumnWithLeftSidebar(187),
        new Core.RightTwoColumn(188),
        new Core.LeftTwoColumn(189),
        new Core.RightTwoColumn(190),
        // sorcerer
        new Core.RightChapterHeadingWithSidebar(192),
        new Core.LeftTwoColumn(193),
        new Core.RightTwoColumn(194),
        new Core.LeftTwoColumn(195),
        new Core.RightTwoColumn(196),
        new Core.LeftTwoColumnWithLeftSidebar(197),
        new Core.RightTwoColumnWithMap(198),
        new Core.LeftTwoColumn(199),
        new Core.RightOneColumnWithSidebar(200),
        new Core.LeftTwoColumnWithLeftSidebar(201),
        new Core.RightTwoColumn(202),        
        // wizard
        new Core.RightChapterHeadingWithSidebar(204),
        new Core.LeftTwoColumn(205),
        new Core.RightTwoColumn(206),
        new Core.LeftTwoColumn(207),
        new Core.RightTwoColumn(208),
        new Core.LeftTwoColumnWithLeftSidebar(209),
        new Core.RightTwoColumnWithMap(210),
        new Core.LeftTwoColumn(211),
        new Core.RightOneColumnWithSidebar(212),
        new Core.LeftTwoColumnWithLeftSidebar(213),
        new Core.RightTwoColumn(214),
        // animal companions
        new Core.LeftChapterHeading(215),
        new Core.RightTwoColumn(216),
        new Core.LeftTwoColumn(217),
        new Core.RightTwoColumn(218),
        new Core.LeftTwoColumn(219), 
        // archetypes
        new Core.RightChapterHeading(220),
        new Core.LeftTwoColumn(221),
        new Core.RightTwoColumn(222),
        new Core.LeftTwoColumn(223),
        new Core.RightTwoColumn(224),
        new Core.LeftTwoColumn(225),
        new Core.RightTwoColumn(226),
        new Core.LeftTwoColumn(227),
        new Core.RightTwoColumn(228),
        new Core.LeftTwoColumn(229),
        new Core.RightTwoColumn(230),
        new Core.LeftTwoColumn(231),
        new Core.RightTwoColumn(232),        

        // chapter 4
        new Core.RightChapterHeadingWithSidebar(234),
        new Core.LeftTwoColumn(235),
        // table on 236
        new Core.LeftTwoColumnWithLeftSidebar(240),
        new Core.LeftTwoColumn(238),
        new Core.LeftTwoColumn(239),
        new Core.LeftTwoColumnWithMap(240),
        new Core.LeftTwoColumn(241),
        new Core.RightTwoColumn(242),
        new Core.LeftTwoColumn(243),
        new Core.RightTwoColumn(244),
        new Core.LeftTwoColumnWithMap(245),
        new Core.RightTwoColumn(246),
        new Core.LeftTwoColumn(247),
        new Core.RightTwoColumn(248),
        new Core.LeftTwoColumn(249),
        new Core.RightTwoColumn(250),
        new Core.LeftTwoColumn(251),
        new Core.RightTwoColumn(252),
        new Core.LeftTwoColumn(253),
        new Core.RightTwoColumn(254),

        // feats
        new Core.RightChapterHeading(256),
        // table cont
        // table cont
        new Core.LeftTwoColumn(259),
        new Core.RightTwoColumnWithMap(260),
        new Core.LeftTwoColumn(261),
        new Core.RightTwoColumn(262),
        new Core.LeftTwoColumn(263),
        new Core.RightTwoColumn(264),
        new Core.LeftTwoColumn(265),
        new Core.RightTwoColumn(266),
        new Core.LeftTwoColumn(267),
        new Core.RightTwoColumn(268),
        new Core.LeftTwoColumn(269),
        new Core.RightTwoColumnWithMap(270),
        

        // spells
        // ...
        new Core.LeftTwoColumn(317),
        new Core.RightTwoColumn(318),
        new Core.LeftTwoColumn(319),
        new Core.LeftTwoColumnWithMap(320),
        new Core.LeftTwoColumn(321),
        new Core.RightTwoColumn(322),
        new Core.LeftTwoColumn(323),
        new Core.RightTwoColumn(324),
        new Core.LeftTwoColumn(325),
        new Core.RightTwoColumnWithMap(326),
        new Core.LeftTwoColumn(327),
        new Core.RightTwoColumn(328),
        new Core.LeftTwoColumn(329),
        new Core.RightTwoColumnWithMap(330),

        // hazards
        new Core.LeftTwoColumn(523),
        new Core.RightTwoColumn(524),
        new Core.LeftTwoColumn(525),
        new Core.RightTwoColumn(526),
        new Core.LeftTwoColumn(527),
        new Core.RightTwoColumn(528),
        new Core.LeftTwoColumn(529),
        new Core.RightTwoColumn(530),
    ],
    scenes: [
    ],
    journals: [
    ],
    finalize: () => {
    }
};

export default crbModule;